module data.queue {
   new() =
      (RevList = data.ref.backtrackable:new([])) >>
      module {
         add(Item) :-
            RevList:set([Item | RevList:get]).

         empty :-
            RevList:get = [].

         peek = RevList:get match ([Head | _Tail] -> Head).

         iter(M) :-
            data.list:reverse_iter(RevList:get(), M).

         list = data.list:reverse(RevList:get())
      }.
}